/*********<^_^>***********
***  By Sennikov Ivan  ***
***  IPMM , 13604 / 1  ***
**********<^_^>**********/
#include <iostream>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <cstring>
#include <fstream>
#include<iomanip>
#include<math.h>

using namespace std;

int M, Count, MaxCount; /// M - size of board
int results_count = 0; /// count of allocations
int **board; /// board - array

int** create_board( int M ) /// create board
{

    board = new int*[M];
    for (int i = 0; i < M; i++)
        board[i] = new int[M];
    for (int i = 0; i < M; i++)
        for (int j = 0; j < M; j++)
            board[i][j] = 0;
    return board;
}

void Showboard() /// output array on screen
{
    for (int i = 0; i < M; ++i)
    {
        for(int j = 0; j < M; ++j)
        {
            cout << board[i][j] << " ";
        }
        cout << '\n';
    }
    cout << "Result #" << ++results_count <<"\n\n"; /// increase the number of result
}

void entry( char Entry[] ) /// output results in file
{
    ofstream fout(Entry, ios::app); /// output in file "Entry"
    for (int i = 0; i < M; ++i)
    {
        for(int j = 0; j < M; ++j)
        {
            fout << board[i][j] << " ";
        }
        fout<<'\n';
    }
    fout<<"\n\n";
    fout.close();
}

bool CheckLine( int x ) /// the presence of the figures in the line
{
    for(int i = 0; i < M; i++)
        if(board[x][i])
            return false;
    return true;
}

bool CheckColomn( int y ) /// the presence of the figures in the line
{
    for(int i = 0; i < M; i++)
        if(board[i][y])
          return false;
    return true;
}

bool CheckDiagonal( int x, int y ) /// the presence of the figures in the diagonal
{
    for(int i = 1; x - i >= 0 && y - i >= 0; i++) /// left - up
        if(board[x - i][y - i])
            return false;

    for(int i = 1; x + i < M && y + i < M; i++) /// right - down
        if(board[x + i][y + i])
            return false;
    for(int i = 1; x + i < M && y - i >= 0; i++) /// left - down
        if(board[x + i][y - i])
            return false;

    for(int i = 1; x - i >= 0 && y + i < M; ++i) /// right - up
        if(board[x - i][y + i])
           return false;

    return true;
}

bool CheckQueen( int x, int y ) /// Check point of board if it under attack
{
    if (!CheckLine(x) || !CheckColomn(y) || !CheckDiagonal(x, y))
        return false;
    return true;
}

/// a - number of next line where we put next queen
/// count - count of figures which we already put
void SetQueen( int a, int count ) ///recursion function for queen
{
    for (int i = 0; i < M; ++i)
    {
        if (CheckQueen(a, i))
        {
            board[a][i] = 1;
            if (count + 1 == Count) /// needed count of figures already put
            {
                Showboard();
               // entry("Entry");
            }
            else
            {
                for(int j = a + 1; j < M; j++) /// put next queen in next line
                SetQueen(j, count + 1); /// repeat recursion function
            }
            board[a][i]=0;
        }
    }
}

bool CheckRook( int x, int y ) /// Check point of board if it under attack
{
    if (!CheckColomn(y) || !CheckLine(x))
        return false;
    return true;
}

/// a - number of next line where we put next rook
/// count - count of figures which we already put
void SetRook(int a, int count)
{
    for(int i = 0; i < M; ++i)
    {
        if(CheckRook(a, i))
        {
            board[a][i] = 1;
            if(count + 1 == Count) /// needed count of figures already put
            {
                Showboard();
                entry("Entry");
            }
            else
            {
                for(int j = a + 1; j < M; j++) /// put next queen in next line
                SetRook(j, count + 1); /// repeat recursion function
            }
            board[a][i]=0;
        }
    }
}

bool CheckBishop( int x, int y )
{
    if (!CheckDiagonal(x, y))
        return false;
    return true;
}

/// a - number of next diagonal where we put next elephant
/// count - count of figures which we already put
void SetBishop(int a, int count)
{
    int x, y; /// anchor point of diagonal (extreme left)

    if (a < M)
    {
        x = a;
        y = 0;
    }
    else
    {
        x = M - 1;
        y = (a % M) + 1;
    }
    for(int i = 0; x - i >= 0 && y + i < M; ++i)
    {
        int xe = x - i;
        int ye = y + i;

        if(CheckBishop(xe, ye))
        {
            board[xe][ye] = 1;
            if(count + 1 == Count) /// needed count of figures already put
            {
                Showboard();
                entry("Entry");
            }
            else
            {
                for(int j = a + 1; j < 2*M - 1; j++) /// put next queen in next line
                    SetBishop(j, count + 1); /// repeat recursion function
            }
             board[xe][ye] = 0;
        }
    }
}

bool CheckFigure(int x, int y) /// the presence of the figures in the point (x, y)
{
    return 0 <= x && x < M && 0 <= y && y < M && board[x][y];
}

bool CheckKing( int x, int y ) /// the presence of the king in the square 3x3
{
    for(int i = x - 1; i <= x + 1; i++)
        for(int j = y - 1; j <= y + 1; j++)
            if (CheckFigure(i, j))
                return false;
    return true;
}

/// count - count of figures which we already put
/// point (x, y) - position from which is allowed to put figures
void SetKing(int count, int x, int y)
{
    if(count == Count)
    {
        Showboard();
        entry("Entry");
    }
    for (int j = y; j < M; ++j) /// processed current line
    {
        if(CheckKing(x, j))
        {
            board[x][j] = 1;
            int nextX = x, nextY = j + 1; /// shift position on 1 right or in begin of next line
            if (nextY == M) /// column is last
            {
                nextY = 0; /// run on column
                nextX++; /// plus 1 to line
            }
            SetKing(count + 1, nextX, nextY); /// put next king
                board[x][j]=0;
        }
    }
    for(int i = x + 1; i < M; ++i) /// the processed rectangle below the current line
    {
        for (int j = 0; j < M; ++j)
        {
            if(CheckKing(i, j))
            {
                board[i][j] = 1;
                int nextX = i, nextY = j + 1; /// shift position on 1 right or in begin of next line
                if (nextY == M) /// column is last
                {
                    nextY = 0; /// run on column
                    nextX++; /// plus 1 to line
                }
                SetKing(count + 1, nextX, nextY); /// put next king
                board[i][j] = 0;
            }
        }
    }
}

bool CheckKnight( int x, int y ) /// check knife for all directions
{
    if (CheckFigure(x - 1,y - 2) || CheckFigure(x - 1,y + 2) || CheckFigure(x + 1,y - 2) ||
        CheckFigure(x + 1,y + 2) || CheckFigure(x - 2,y - 1) || CheckFigure(x - 2,y + 1) ||
        CheckFigure(x + 2,y - 1) || CheckFigure(x + 2,y + 1))
        return false;
    return true;
}

/// count - count of figures which we already put
void SetKnight( int count, int x, int y)
{
    if(count == Count)
    {
        Showboard();
        entry("Entry");
    }
    for (int j = y; j < M; ++j) /// processed current line
    {
        if(CheckKnight(x, j))
        {
            board[x][j] = 1;
            int nextX = x, nextY = j + 1; /// shift position on 1 right or in begin of next line
            if (nextY == M) /// column is last
            {
                nextY = 0; /// run on column
                nextX++; /// plus 1 to line
            }
            SetKnight(count + 1, nextX, nextY); /// put next knife
            board[x][j] = 0;
        }
    }
    for(int i = x + 1; i < M; ++i) /// the processed rectangle below the current line
    {
        for (int j = 0; j < M; ++j)
        {
            if(CheckKnight(i, j))
            {
                board[i][j] = 1;
                int nextX = i, nextY = j+1; /// shift position on 1 right or in begin of next line
                if (nextY == M) /// column is last
                {
                    nextY = 0; /// run on column
                    nextX++; /// plus 1 to line
                }
                SetKnight(count + 1, nextX, nextY);
                board[i][j] = 0;
            }
        }
    }
}

int main()
{
    int run = 1;

    ofstream Entry("Entry", ios::trunc);/// save in file
    Entry.close();

    do
    {
        cout << "Input size of board (even): ";
        cin >> M;
    } while(M % 2 != 0);

    board = create_board(M);

    while(run)
    {
        cout<<"\n\nMENU:\n\n0 - exit\n1 - Queen\n2 - Rook\n3 - Bishop\n4 - King\n5 - Knight\n\n"<< endl;
        switch(_getch())
        {
        case '0':
            cout << "Program finished..\n";
            run = 0;
            break;
        case '1':
            if(M < 8)
                MaxCount = M - 1;
            else
                MaxCount = M;
            cout << "Maximum count of figures = " << MaxCount << endl;
            do
            {
                cout << "Input count of figures: ";
                cin >> Count;
            } while(Count > MaxCount);
            for(int i = 0; i < M; i++)
                SetQueen(i, 0);
            entry("Entry");
            results_count = 0;
            break;
            case '2':
            MaxCount = M;
            cout << "Maximum count of figures = " << MaxCount << endl;
            do
            {
                cout << "Input count of figures: ";
                cin >> Count;
            } while(Count > MaxCount);
            for(int i = 0; i < M; i++)
                SetRook(i, 0);
            entry("Entry");
            results_count = 0;
            break;
            case '3':
            MaxCount = 2*M - 1;
            cout << "Maximum count of figures = " << MaxCount << endl;
            do
            {
                cout << "Input count of figures: ";
                cin >> Count;
            } while(Count > MaxCount);
            for(int i = 0; i < M; i++)
                SetBishop(i, 0);
            entry("Entry");
           results_count = 0; results_count = 0;
            break;
            case '4':
            MaxCount = M*M/4;
            cout << "Maximum count of figures = " << MaxCount << endl;
            do
            {
                cout << "Input count of figures: ";
                cin >> Count;
            } while(Count > MaxCount);
            for(int i = 0; i < M; i++)
                SetKing(0, 0, 0);
            entry("Entry");
            results_count = 0;
            break;
            case '5':
            MaxCount = M*M/2;
            cout << "Maximum count of figures = " << MaxCount << endl;
            do
            {
                cout << "Input count of figures: ";
                cin >> Count;
            } while(Count > MaxCount);
            for(int i = 0; i < M; i++)
                SetKnight(0, 0, 0);
            entry("Entry");
            results_count = 0;
            break;
            default:
                cout << "ICORRECT CHOOSE!!!";
        }
    }
    system("PAUSE");
    return 0;
}

